#!/usr/bin/env groovy

@Grab('org.hsqldb:hsqldb:2.4.0')
@GrabConfig(systemClassLoader=true)
import groovy.sql.Sql

def csvFile = './products.csv' as File

def url = 'jdbc:hsqldb:file:./db/products'
def drv = 'org.hsqldb.jdbcDriver'
def usr = 'sa'
def pwd = ''
def tbl = 'products'
def TBL = """
    DROP TABLE ${tbl} IF EXISTS;
    CREATE TABLE ${tbl} (
        id       INTEGER GENERATED BY DEFAULT AS IDENTITY,
        name     VARCHAR(128),
        price    DECIMAL(8,2),
        stock    INTEGER,
        created  DATE
    );
""".toString()
def INS = "INSERT INTO ${tbl} (name,price,stock,created) VALUES (?,?,?,?)".toString()
def GET = "SELECT * FROM ${tbl} ORDER BY price DESC".toString()
def CUR = 'SEK'

Sql.withInstance(url, usr, pwd, drv) {sql ->
    sql.execute TBL

    csvFile.eachLine {csv ->
        if (csv.startsWith('name;')) return
        
        //name;price;count;date
        //Pepper;543.46;9;2017-08-13 06:42:29
        def fields = csv.split ';'
        String   name    = fields[0]
        Float    price   = fields[1] as Float
        Integer  stock   = fields[2] as Integer
        Date     created = Date.parse('yyyy-MM-dd HH:mm:ss', fields[3]) 
        
        sql.execute INS, [name,price,stock,created]
    }
    
    //[ID:46, NAME:Melon - Honey Dew, PRICE:157.46, STOCK:3, CREATED:2017-07-17]
    printf '  %s  %-35s %3s %6s  %8s %-12s%n', 
        'ID', 'Product', ' ', 'Price', 'In Stock', 'Created'
    sql.eachRow(GET) {row -> 
        printf '[%03d] %-35s %3s %3.2f  %2d items (%s)%n', 
               row.id, row.name, CUR, row.price, row.stock, row.created
    }
}
